from flask import request, redirect, current_app
from stravalib.client import Client
from requests.exceptions import HTTPError

class Strava():
    @classmethod
    def check_auth(cls, token = None):
        if not token:
            # TODO: get token from database
            token = "obviously invalid"
        strava = Client(token)
        try:
            return strava.get_athlete().email
        except (HTTPError, AttributeError):
            return False

    @classmethod
    def authorize(cls, code = None):
        """Redirect to Strava to get an access token."""
        code = code or request.args.get('code', None)
        if not code:
            strava = Client()
            source_url = request.referrer
            authorized_url = request.url
            authorize_url = strava.authorization_url(
                client_id=current_app.config['STRAVA_APP_ID'], redirect_uri=authorized_url, state=source_url)
            return redirect(authorize_url)
        else:
            source_url = request.args.get('state', None)
            strava = Client()
            access_token = strava.exchange_code_for_token(
                client_id=current_app.config['STRAVA_APP_ID'],
                client_secret=current_app.config['STRAVA_APP_SECRET'],
                code=code)
            strava.access_token = access_token
            # TODO: store the access token
            athlete = strava.get_athlete()
            if source_url:
                return redirect(source_url)
            return "Auth success: {}".format(athlete.email)
